# Migrating to 2.1 #

The following guide should be used for migrating from 2.0 to 2.1. Please refer to previous migration guides if you are upgrading from a lower version.

## Sass ##

* Rename `$vendor-prefix` to `$namespace`.
* Rename `grid-gutter()` to `gutter()`.
* Rename `remove-selector-char()` to `remove-selector()`.

## JavaScript ##

* Rename `Toolkit.create()` to `Toolkit.createPlugin()`.
* Rename `Toolkit.vendor` to `Toolkit.namespace`.

## Components ##

* All `template` option strings have been replaced with functions. Be wary of this change.
* The `created` property was removed.
* The `runtime` property was removed.
* The `nodes` and `elements` properties are only available in `CompositeComponent` components.
* The `createElement()` function was moved from the `Component` class to `TemplateComponent`.

### Drop ###

* The `hideOpened` option was removed.

### Flyout ###

* Rename the `current` property to `url`.
* Rename the `menus` property to `elements`.

### Lazy Load ###

* Rename the `elements` property to `items`.

### Popover ###

* The `elementHead` and `elementBody` properties were removed.

### Toast ###

* Rename `template` option to `wrapperTemplate`.
* Rename `toastTemplate` option to `template`.

### Tooltip ###

* The `elementHead` and `elementBody` properties were removed.
