# Contributing #

Toolkit is continuously growing with every new release, and with that comes the opportunity for the community to be involved. We're always looking for bug fixes, feature requests, and in-depth discussions.

## Reporting A Bug ##

Found a bug? Report the issue on the [official GitHub repository](https://github.com/titon/toolkit/issues) with the following information included.

* A snippet of code to reproduce the issue or a live URL of where the issue can be tested
* The browser, the device, the OS, and their versions
* The version of Toolkit and jQuery being used

### Known Issues ###

* [Android #19827](https://code.google.com/p/android/issues/detail?id=19827) -
    Touch `touchend` events are not triggered unless `preventDefault()` is called during `touchstart` or `touchmove` *(Temporarily patched)*

## Submitting A Pull Request ##

Fixed a bug or added new functionality? Submit a pull request on the [official GitHub repository](https://github.com/titon/toolkit/pulls) with information on the detailed bug (mentioned above) or details on the new functionality. When submitting a pull, the following guidelines must be followed.

* If fixing a bug, must reference an existing issue
* If adding new functionality, must include code snippets or examples for testing
* Code changes must not include other changes outside the scope of the initial issue
* Must follow the [JS conventions](../development/js/conventions.md) and [CSS conventions](../development/bem.md)

## Contributors ##

Individuals who helped in the growth of Toolkit by fixing a major issue or adding new features are listed below. Why not be the first?
